# -*- coding: utf-8 -*-

from ConfigParser import SafeConfigParser
import codecs

from twython import Twython
import twitter_text
import MySQLdb
from jinja2 import Environment, FileSystemLoader

class ReadNewTweets:

    """We use the Twython module to issue a GET statuses/user_timeline
    request. The tweets of the response are returned by the method
    read_user_timeline as list of Unicode strings.

    These are some API 1.1 docs about the GET statuses/user_timeline requests:
    https://dev.twitter.com/docs/api/1.1/get/statuses/user_timeline

    In our tests we found that OAUTH authentication is a prerequisite for GET
    statuses/timeline requests. The Twython docs are vague about this, cf the
    comments of the get_user_timeline.py example: "We won't authenticate for
    this, but sometimes it's necessary"
    https://raw.github.com/ryanmcgrath/twython/master/core_examples/get_user_timeline.py

    This class expects three arguments:
    1. The location of a configuration file with the necessary data for
    authentication. We use ConfigParser to read the configuration file. See
    config.sample.ini file.
    2. A twitter screen_name: "The screen name of the user for whom to return
    results for"
    3. A GET statuses/user_timeline count parameter: "Specifies the number of
    tweets to try and retrieve [...]".

    The read_user_timeline method will return the tweets of the request
    response formatted as a list of Unicode type instances, Unicode strings,
    u'☺☻'.  We will often use this type of tweet list...
    
    """

    def __init__(self, config_file, screen_name, count):
        """config_file is a string and should point to a configuration file
        with the necessary credentials for OAUTH. We use ConfigParser to read
        the configuration file.

        screen_name is a string and corresponds to the user whose timeline we
        will read.

        count is an integer and corresponds to the number of tweets we will
        read.

        At the moment, the HTML jinja2 template expects 70 tweets. The count
        argument may be overkill...

        """
        self.config_file = config_file
        self.screen_name = screen_name
        self.count = count

    def read_config_file(self):
        """We use ConfigParser to read the configuration file with the
        necessary credentials for OAUTH.

        """
        parser = SafeConfigParser()
        parser.read('config.ini')

        self.app_key = parser.get('Twitter_OAUTH', 'app_key')
        self.app_secret = parser.get('Twitter_OAUTH', 'app_secret')
        self.oauth_token = parser.get('Twitter_OAUTH', 'oauth_token')
        self.oauth_token_secret = parser.get('Twitter_OAUTH', 'oauth_token_secret')

    def read_user_timeline(self):
        """We connect to twitter, and issue a GET statuses/user_timeline
        request with self.screen_name and self.count parameters.
        
        A response's u'text' field corresponds to a "tweet".  See the API 1.1
        docs for a map of a typical response:
        https://dev.twitter.com/docs/api/1.1/get/statuses/user_timeline

        This method's return value is some tweets packaged as list of Unicode
        strings.

        """
        twitter = Twython(app_key=self.app_key, app_secret=self.app_secret,
                oauth_token=self.oauth_token,
                oauth_token_secret=self.oauth_token_secret)

        tweets = twitter.getUserTimeline(screen_name=self.screen_name, count=self.count)

        list_of_tweets = []
        for tweet in tweets:
            list_of_tweets.append(tweet[u'text'])

        return list_of_tweets

class WriteNewTweetsToDB:

    """We write some tweets to a database.

    This class expects two arguments:
    1. The location of a configuration file with the usual MySQL connection
    stuff (host, user, pwd, db name). We use ConfigParser to read the
    configuration file. See config.sample.ini file.
    2. A list of some tweets as say returned by the read_user_timeline method
    of ReadNewTweets.

    The list_of_tweets strings will be written to the database of the
    configuration file.

    This class is not really Twitter-dependent and the strings of Argument #2
    could be anything...

    """

    def __init__(self, config_file, list_of_tweets):
        """config_file is a string and should point to a configuration file
        with the usual MySQL connection stuff. See config.sample.ini file...
        
        We use ConfigParser to read the configuration file.

        list_of_tweets is a list as say generated by the read_user_timeline
        method of the ReadNewTweets class.

        """
        self.config_file = config_file
        self.list_of_tweets = list_of_tweets

    def read_config_file(self):
        """We use ConfigParser to fetch the usual MySQL connection stuff"""
        parser = SafeConfigParser()
        parser.read(self.config_file)

        self.db_host = parser.get('MySQL', 'host')
        self.db_user = parser.get('MySQL', 'user')
        self.db_password = parser.get('MySQL', 'password')
        self.db_database = parser.get('MySQL', 'database')

    def write_tweets_to_db(self):
        """We write some tweets to the database.

        We loop over the self.list_of_tweets list, and write each tweet to the
        database.

        For the Unicode tweaks, we read the following:
        http://dev.mysql.com/doc/refman/5.0/en/charset-applications.html
        http://stackoverflow.com/questions/8365660/python-mysql-unicode-and-encoding

        """
        connection = MySQLdb.connect(host = self.db_host,
                user = self.db_user,
                passwd = self.db_password,
                db = self.db_database,
                charset = 'utf8',
                use_unicode = True)

        cursor = connection.cursor()
        sql_statement = "CREATE TABLE IF NOT EXISTS tweets (Id INT PRIMARY KEY AUTO_INCREMENT, tweet VARCHAR(140))"
        cursor.execute(sql_statement)

        for tweet in self.list_of_tweets:
            cursor.execute('INSERT INTO tweets(tweet) VALUES(%s)', (tweet,))

class ReadTweetsFromDB:

    """We read some tweets from a database and return a list of tweets.

    This class expects one argument:
    1. The location of a configuration file with the usual MySQL connection
    stuff (host, user, pwd, db name). We use ConfigParser to read the
    configuration file. See config.sample.ini file.

    The database has been created by say the write_tweets_to_db method of the
    WriteTweetsToDB class.

    The return value of read_tweets_from_db is a list of tweets as in the
    read_user_timeline method of the ReadNewTweets class.

    """

    def __init__(self, config_file):
        """config_file is a string and should point to a configuration file
        with the usual MySQL connection stuff. See config.sample.ini file...
        
        We use ConfigParser to read the configuration file.

        """
        self.config_file = config_file

    def read_config_file(self):
        """We use ConfigParser to fetch the usual MySQL connection stuff"""
        parser = SafeConfigParser()
        parser.read(self.config_file)

        self.db_host = parser.get('MySQL', 'host')
        self.db_user = parser.get('MySQL', 'user')
        self.db_password = parser.get('MySQL', 'password')
        self.db_database = parser.get('MySQL', 'database')

    def read_tweets_from_db(self):
        """We connect to the database and retrieve some tweets.
        
        This method's return value is a list of tweets as in the
        read_user_timeline method of the ReadNewTweets class.

        """
        connection = MySQLdb.connect(host = self.db_host,
                user = self.db_user,
                passwd = self.db_password,
                db = self.db_database,
                charset = 'utf8',
                use_unicode = True)

        cursor = connection.cursor()
        cursor.execute("SELECT * FROM tweets")

        tweets = cursor.fetchall()
        list_of_tweets = []
        for row in tweets:
            list_of_tweets.append(row[1])

        return list_of_tweets

class WriteTweetsToHTMLFile:

    """We write some tweets to a HTML file via Jinja templating.

    This class expects four arguments:
    1. A string that points to a location in the file system where Jinja
    templates are stored. We use the "FileSystemLoader" Jinja loader. The
    Jinja documentation says: "The loader takes the path to the templates as
    string" http://jinja.pocoo.org/docs/api/#jinja2.FileSystemLoader
    2. A string that points to a Jinja template file in the location specified
    by Argument #1.
    3. A list of some tweets as say returned by the read_tweets_from_db method
    of ReadTweetsFromDB.  FWIW read_user_timeline of ReadNewTweets returns the
    same type of tweet lists...
    4. A string that points to a location in the file system where we can
    store our HTML.

    If it doesn't exist already, the file html_file will be written anew.

    """

    def __init__(self, template_search_path, template_name, list_of_tweets,
            html_file):
        """template_search_path is a Jinja templates folder; and template_name
        is a template therein.

        list_of_tweets is our list of tweets

        If it doesn't exist already, the file html_file will be created and
        our Jinja-generated HTML will be written to it.
        """

        self.template_search_path = template_search_path
        self.template_name = template_name
        self.list_of_tweets = list_of_tweets
        self.html_file = html_file

    def autolink_list_of_tweets(self):
        """We auto link the plain text aspects of tweets. See "Twitter text
        conformance":
        https://github.com/twitter/twitter-text-conformance

        We use the twitter-text-py module:
        pip install twitter-text-py

        twitter-text-py documentation says the following about autolinking:
        "Add @<a></a>@ tags around the usernames, lists, hashtags and URLs in
        the provided text [...]"
        https://raw.github.com/dryan/twitter-text-py/master/README.textile

        We need to do this in order to render the tweets on the browser...
        """

        self.list_of_tweets_autolinked = []
        for tweet in self.list_of_tweets:
            my_autolink = twitter_text.Autolink(tweet)
            self.list_of_tweets_autolinked.append(my_autolink.auto_link())

    def write_html_file(self):
        """We write the autolinked tweets to a HTML file via Jinja templating.

        If it doesn't exist already a new file will be created and our HTML
        will be written to it. The new file's name is self.html_file
        
        We pass the list_of_tweets_autolinked list to Jinja's render() method
        for templates.

        See also our Jinja template: template.html
        """

        env = Environment(loader=FileSystemLoader(self.template_search_path))
        template = env.get_template(self.template_name)
        f = codecs.open(self.html_file, mode="w", encoding='utf-8')
        f.write(template.render(list_of_tweets=self.list_of_tweets_autolinked))
